// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v4.25.6
// source: pipeline_template.proto

package gen

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	PipelineTemplates_GetPipelineTemplateByID_FullMethodName = "/martiancloud.phobos.api.pipelinetemplate.PipelineTemplates/GetPipelineTemplateByID"
	PipelineTemplates_GetPipelineTemplates_FullMethodName    = "/martiancloud.phobos.api.pipelinetemplate.PipelineTemplates/GetPipelineTemplates"
	PipelineTemplates_CreatePipelineTemplate_FullMethodName  = "/martiancloud.phobos.api.pipelinetemplate.PipelineTemplates/CreatePipelineTemplate"
	PipelineTemplates_UploadPipelineTemplate_FullMethodName  = "/martiancloud.phobos.api.pipelinetemplate.PipelineTemplates/UploadPipelineTemplate"
	PipelineTemplates_DeletePipelineTemplate_FullMethodName  = "/martiancloud.phobos.api.pipelinetemplate.PipelineTemplates/DeletePipelineTemplate"
	PipelineTemplates_GetPipelineTemplateData_FullMethodName = "/martiancloud.phobos.api.pipelinetemplate.PipelineTemplates/GetPipelineTemplateData"
)

// PipelineTemplatesClient is the client API for PipelineTemplates service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// PipelineTemplates implements all functionality related to a Phobos
// PipelineTemplate.
type PipelineTemplatesClient interface {
	// GetPipelineTemplateByID returns a PipelineTemplate by an ID.
	GetPipelineTemplateByID(ctx context.Context, in *GetPipelineTemplateByIdRequest, opts ...grpc.CallOption) (*PipelineTemplate, error)
	// GetPipelineTemplates returns a paginated list of PipelineTemplates.
	GetPipelineTemplates(ctx context.Context, in *GetPipelineTemplatesRequest, opts ...grpc.CallOption) (*GetPipelineTemplatesResponse, error)
	// CreatePipelineTemplate creates a new PipelineTemplate.
	CreatePipelineTemplate(ctx context.Context, in *CreatePipelineTemplateRequest, opts ...grpc.CallOption) (*PipelineTemplate, error)
	// UploadPipelineTemplate uploads to a PipelineTemplate.
	UploadPipelineTemplate(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadPipelineTemplateRequest, emptypb.Empty], error)
	// DeletePipelineTemplate deletes a PipelineTemplate.
	DeletePipelineTemplate(ctx context.Context, in *DeletePipelineTemplateRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// GetPipelineTemplateData returns the template data as a stream of chunks
	GetPipelineTemplateData(ctx context.Context, in *GetPipelineTemplateDataRequest, opts ...grpc.CallOption) (grpc.ServerStreamingClient[GetPipelineTemplateDataResponse], error)
}

type pipelineTemplatesClient struct {
	cc grpc.ClientConnInterface
}

func NewPipelineTemplatesClient(cc grpc.ClientConnInterface) PipelineTemplatesClient {
	return &pipelineTemplatesClient{cc}
}

func (c *pipelineTemplatesClient) GetPipelineTemplateByID(ctx context.Context, in *GetPipelineTemplateByIdRequest, opts ...grpc.CallOption) (*PipelineTemplate, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(PipelineTemplate)
	err := c.cc.Invoke(ctx, PipelineTemplates_GetPipelineTemplateByID_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pipelineTemplatesClient) GetPipelineTemplates(ctx context.Context, in *GetPipelineTemplatesRequest, opts ...grpc.CallOption) (*GetPipelineTemplatesResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(GetPipelineTemplatesResponse)
	err := c.cc.Invoke(ctx, PipelineTemplates_GetPipelineTemplates_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pipelineTemplatesClient) CreatePipelineTemplate(ctx context.Context, in *CreatePipelineTemplateRequest, opts ...grpc.CallOption) (*PipelineTemplate, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(PipelineTemplate)
	err := c.cc.Invoke(ctx, PipelineTemplates_CreatePipelineTemplate_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pipelineTemplatesClient) UploadPipelineTemplate(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadPipelineTemplateRequest, emptypb.Empty], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &PipelineTemplates_ServiceDesc.Streams[0], PipelineTemplates_UploadPipelineTemplate_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[UploadPipelineTemplateRequest, emptypb.Empty]{ClientStream: stream}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PipelineTemplates_UploadPipelineTemplateClient = grpc.ClientStreamingClient[UploadPipelineTemplateRequest, emptypb.Empty]

func (c *pipelineTemplatesClient) DeletePipelineTemplate(ctx context.Context, in *DeletePipelineTemplateRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, PipelineTemplates_DeletePipelineTemplate_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pipelineTemplatesClient) GetPipelineTemplateData(ctx context.Context, in *GetPipelineTemplateDataRequest, opts ...grpc.CallOption) (grpc.ServerStreamingClient[GetPipelineTemplateDataResponse], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &PipelineTemplates_ServiceDesc.Streams[1], PipelineTemplates_GetPipelineTemplateData_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[GetPipelineTemplateDataRequest, GetPipelineTemplateDataResponse]{ClientStream: stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PipelineTemplates_GetPipelineTemplateDataClient = grpc.ServerStreamingClient[GetPipelineTemplateDataResponse]

// PipelineTemplatesServer is the server API for PipelineTemplates service.
// All implementations must embed UnimplementedPipelineTemplatesServer
// for forward compatibility.
//
// PipelineTemplates implements all functionality related to a Phobos
// PipelineTemplate.
type PipelineTemplatesServer interface {
	// GetPipelineTemplateByID returns a PipelineTemplate by an ID.
	GetPipelineTemplateByID(context.Context, *GetPipelineTemplateByIdRequest) (*PipelineTemplate, error)
	// GetPipelineTemplates returns a paginated list of PipelineTemplates.
	GetPipelineTemplates(context.Context, *GetPipelineTemplatesRequest) (*GetPipelineTemplatesResponse, error)
	// CreatePipelineTemplate creates a new PipelineTemplate.
	CreatePipelineTemplate(context.Context, *CreatePipelineTemplateRequest) (*PipelineTemplate, error)
	// UploadPipelineTemplate uploads to a PipelineTemplate.
	UploadPipelineTemplate(grpc.ClientStreamingServer[UploadPipelineTemplateRequest, emptypb.Empty]) error
	// DeletePipelineTemplate deletes a PipelineTemplate.
	DeletePipelineTemplate(context.Context, *DeletePipelineTemplateRequest) (*emptypb.Empty, error)
	// GetPipelineTemplateData returns the template data as a stream of chunks
	GetPipelineTemplateData(*GetPipelineTemplateDataRequest, grpc.ServerStreamingServer[GetPipelineTemplateDataResponse]) error
	mustEmbedUnimplementedPipelineTemplatesServer()
}

// UnimplementedPipelineTemplatesServer must be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedPipelineTemplatesServer struct{}

func (UnimplementedPipelineTemplatesServer) GetPipelineTemplateByID(context.Context, *GetPipelineTemplateByIdRequest) (*PipelineTemplate, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetPipelineTemplateByID not implemented")
}
func (UnimplementedPipelineTemplatesServer) GetPipelineTemplates(context.Context, *GetPipelineTemplatesRequest) (*GetPipelineTemplatesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetPipelineTemplates not implemented")
}
func (UnimplementedPipelineTemplatesServer) CreatePipelineTemplate(context.Context, *CreatePipelineTemplateRequest) (*PipelineTemplate, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreatePipelineTemplate not implemented")
}
func (UnimplementedPipelineTemplatesServer) UploadPipelineTemplate(grpc.ClientStreamingServer[UploadPipelineTemplateRequest, emptypb.Empty]) error {
	return status.Errorf(codes.Unimplemented, "method UploadPipelineTemplate not implemented")
}
func (UnimplementedPipelineTemplatesServer) DeletePipelineTemplate(context.Context, *DeletePipelineTemplateRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeletePipelineTemplate not implemented")
}
func (UnimplementedPipelineTemplatesServer) GetPipelineTemplateData(*GetPipelineTemplateDataRequest, grpc.ServerStreamingServer[GetPipelineTemplateDataResponse]) error {
	return status.Errorf(codes.Unimplemented, "method GetPipelineTemplateData not implemented")
}
func (UnimplementedPipelineTemplatesServer) mustEmbedUnimplementedPipelineTemplatesServer() {}
func (UnimplementedPipelineTemplatesServer) testEmbeddedByValue()                           {}

// UnsafePipelineTemplatesServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to PipelineTemplatesServer will
// result in compilation errors.
type UnsafePipelineTemplatesServer interface {
	mustEmbedUnimplementedPipelineTemplatesServer()
}

func RegisterPipelineTemplatesServer(s grpc.ServiceRegistrar, srv PipelineTemplatesServer) {
	// If the following call pancis, it indicates UnimplementedPipelineTemplatesServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&PipelineTemplates_ServiceDesc, srv)
}

func _PipelineTemplates_GetPipelineTemplateByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetPipelineTemplateByIdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PipelineTemplatesServer).GetPipelineTemplateByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PipelineTemplates_GetPipelineTemplateByID_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PipelineTemplatesServer).GetPipelineTemplateByID(ctx, req.(*GetPipelineTemplateByIdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PipelineTemplates_GetPipelineTemplates_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetPipelineTemplatesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PipelineTemplatesServer).GetPipelineTemplates(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PipelineTemplates_GetPipelineTemplates_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PipelineTemplatesServer).GetPipelineTemplates(ctx, req.(*GetPipelineTemplatesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PipelineTemplates_CreatePipelineTemplate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreatePipelineTemplateRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PipelineTemplatesServer).CreatePipelineTemplate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PipelineTemplates_CreatePipelineTemplate_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PipelineTemplatesServer).CreatePipelineTemplate(ctx, req.(*CreatePipelineTemplateRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PipelineTemplates_UploadPipelineTemplate_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(PipelineTemplatesServer).UploadPipelineTemplate(&grpc.GenericServerStream[UploadPipelineTemplateRequest, emptypb.Empty]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PipelineTemplates_UploadPipelineTemplateServer = grpc.ClientStreamingServer[UploadPipelineTemplateRequest, emptypb.Empty]

func _PipelineTemplates_DeletePipelineTemplate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeletePipelineTemplateRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PipelineTemplatesServer).DeletePipelineTemplate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PipelineTemplates_DeletePipelineTemplate_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PipelineTemplatesServer).DeletePipelineTemplate(ctx, req.(*DeletePipelineTemplateRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PipelineTemplates_GetPipelineTemplateData_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(GetPipelineTemplateDataRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(PipelineTemplatesServer).GetPipelineTemplateData(m, &grpc.GenericServerStream[GetPipelineTemplateDataRequest, GetPipelineTemplateDataResponse]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PipelineTemplates_GetPipelineTemplateDataServer = grpc.ServerStreamingServer[GetPipelineTemplateDataResponse]

// PipelineTemplates_ServiceDesc is the grpc.ServiceDesc for PipelineTemplates service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var PipelineTemplates_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "martiancloud.phobos.api.pipelinetemplate.PipelineTemplates",
	HandlerType: (*PipelineTemplatesServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetPipelineTemplateByID",
			Handler:    _PipelineTemplates_GetPipelineTemplateByID_Handler,
		},
		{
			MethodName: "GetPipelineTemplates",
			Handler:    _PipelineTemplates_GetPipelineTemplates_Handler,
		},
		{
			MethodName: "CreatePipelineTemplate",
			Handler:    _PipelineTemplates_CreatePipelineTemplate_Handler,
		},
		{
			MethodName: "DeletePipelineTemplate",
			Handler:    _PipelineTemplates_DeletePipelineTemplate_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "UploadPipelineTemplate",
			Handler:       _PipelineTemplates_UploadPipelineTemplate_Handler,
			ClientStreams: true,
		},
		{
			StreamName:    "GetPipelineTemplateData",
			Handler:       _PipelineTemplates_GetPipelineTemplateData_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "pipeline_template.proto",
}
